; WFP_reader v.2005-05-25, http://www.geocities.com/xmemor/2lz/tinyasm.html
; (receives output info from WinFinderPoster)

.386
.model			flat,stdcall
option			casemap:none

include			\masm32\include\windows.inc
include			\masm32\include\user32.inc
include			\masm32\include\kernel32.inc
include 		\masm32\include\gdi32.inc
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\gdi32.lib

.const
WS_EX_LAYERED	equ 80000h

.data
classname		db "WFP_reader",0
about				db "by kero <geocities.com/xmemor> v.2005-05-25",0
wfp					db 	"WinFinderPoster",0
sttc				db "Static",0
frmt				db "  #%8.8lX",13,10,"  %s  %s",13,10,13,10,"  rect:  [%d,%d; %d*%d]",13,10,"  rgn:  %d",13,10,13,10,"  id:  %lu  (#%lX)",13,10,13,10,"  tid:  %lu  (#%lX)",13,10
						db "  pid:  %lu  (#%lX)",13,10,13,10,"  %s",13,10,13,10,"  {%s}",13,10,13,10,"  ",0

popup				db "WS_POPUP",0
child				db "WS_CHILD",0
overlapped	db "WS_OVERLAPPED",0
alph				db "WS_EX_LAYERED",0

.data?
hinst				HINSTANCE ?
hw					HWND ?
hwnd1				HWND ?
hwin				HWND ?
hrgn				HRGN ?
trgn				dd ?
style				dd ?
mess_id			dd ?
abuf				db 16 dup(?)

.code

;################################################################################################

WndProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	local id:DWORD
	local pid:DWORD
	local tid:DWORD
	local hsnap:DWORD
	local pe32:PROCESSENTRY32
	local buf[1024]:BYTE
	local buf1[MAX_PATH+1]:BYTE
	local buf2[1024]:BYTE
	local wdth:DWORD
	local hght:DWORD
	local rt:RECT

	mov eax,uMsg
	.if eax==WM_DESTROY
		invoke DeleteObject,hrgn
		invoke PostQuitMessage,0

	.elseif eax==WM_CREATE
		invoke CreateWindowEx,0,offset sttc,0,WS_CHILD or WS_VISIBLE,0,0,230,280,hWnd,0,hinst,0
		mov hwnd1,eax
		invoke CreateRectRgn,0,0,0,0
		mov hrgn,eax
		invoke SendMessageTimeout,HWND_BROADCAST,mess_id,0,0,SMTO_ABORTIFHUNG,20,0

	.elseif eax==mess_id
		mov byte ptr buf,0
		mov eax,lParam
		mov hwin,eax
		invoke GetWindowRect,hwin,addr rt
		mov eax,rt.right
		sub eax,rt.left
		mov wdth,eax
		mov eax,rt.bottom
		sub eax,rt.top
		mov hght,eax
		invoke GetWindowRgn,hwin,hrgn
		mov trgn,eax
		invoke GetWindowLong,hwin,GWL_ID
		mov id,eax

		invoke GetWindowLong,hwin,GWL_STYLE
		and eax,WS_CHILD or WS_POPUP
		.if eax==WS_CHILD
			mov eax,offset child
		.elseif eax==WS_POPUP
			mov eax,offset popup
		.else
			mov eax,offset overlapped
		.endif
		mov style,eax

		mov byte ptr abuf,0
		invoke GetWindowLong,hwin,GWL_EXSTYLE
		and eax,WS_EX_LAYERED
		test eax,eax
		jz @f
		invoke lstrcpy,addr abuf,addr alph
@@:
		invoke GetWindowThreadProcessId,hwin,addr pid
		mov tid,eax
		invoke CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,pid
		mov	hsnap,eax
		mov	pe32.dwSize,sizeof pe32
		invoke Process32First,hsnap,addr pe32 
@@:
		test eax,eax
		jz @false
		mov eax,pid
		cmp pe32.th32ProcessID,eax
		jz @f
		invoke Process32Next,hsnap,addr pe32
		jmp @b
@false:
		lea eax,pe32.szExeFile
		mov word ptr [eax],[0]['?']				; "?",0
@@:
		invoke GetClassName,hwin,addr buf1,MAX_PATH
		invoke wsprintf,addr buf,addr frmt,hwin,style,addr abuf,rt.left,rt.top,wdth,hght,trgn,id,id,tid,tid,pid,pid,addr pe32.szExeFile,addr buf1
		invoke SendMessageTimeout,hwin,WM_GETTEXT,MAX_PATH,addr buf1,SMTO_ABORTIFHUNG,20,0
		invoke lstrcat,addr buf,addr buf1
		invoke lstrcmp,addr buf,addr buf2
		test eax,eax
		jz @f
		invoke lstrcpy,addr buf2,addr buf
		invoke SendMessage,hwnd1,WM_SETTEXT,0,addr buf
@@:

	.elseif eax==WM_RBUTTONUP
;		invoke PostMessage,hWnd,WM_DESTROY,0,0
		invoke DestroyWindow,hWnd

	.elseif eax==WM_LBUTTONDOWN
;		invoke ReleaseCapture
    invoke SendMessage,hWnd,WM_NCLBUTTONDOWN,HTCAPTION,lParam

	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
WndProc endp

;################################################################################################

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,lpszArgs:LPSTR,CmdShow:DWORD
	local wc:WNDCLASS
	local msg:MSG
	local hwnd:HWND

	mov wc.style,0
	mov wc.lpfnWndProc,offset WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	mov eax,hInst
	mov wc.hInstance,eax
	mov wc.hbrBackground,COLOR_WINDOW
	mov wc.lpszMenuName,0
	mov wc.lpszClassName,offset classname
	invoke LoadIcon,0,IDI_APPLICATION
	mov wc.hIcon, eax
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	invoke RegisterClass,addr wc
	invoke CreateWindowEx,WS_EX_TOPMOST or WS_EX_TOOLWINDOW,offset classname,0,WS_POPUP,10,10,230,280,0,0,hInst,0
	mov hwnd,eax
	invoke ShowWindow,hwnd,CmdShow
	invoke UpdateWindow,hwnd
	.while TRUE
		invoke GetMessage,addr msg,0,0,0
		.break .if (!eax)
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov eax,msg.wParam
	ret
WinMain endp

;################################################################################################

start:
	invoke FindWindow,offset wfp,0
	test eax,eax
	jnz @f
	invoke MessageBox,0,offset wfp,0,40020h
	jmp @@@
@@:
	mov hw,eax

;		invoke RegisterWindowMessage,offset wfp
; or
;		invoke RegisterClipboardFormat,offset wfp
; or
		.data?
		wcs		WNDCLASS <?>
		.code
		mov wcs.lpszClassName,offset wfp
		invoke RegisterClass,offset wcs
		and eax,0ffffh
	test eax,eax
	jz @@@
	mov mess_id,eax

	invoke GetModuleHandle,0
	mov hinst,eax
	invoke WinMain,eax,0,0,SW_SHOWDEFAULT
@@@:
	invoke ExitProcess,eax
end start

;################################################################################################
