; WinFinderPoster v.2005-05-25, http://www.geocities.com/xmemor/2lz/tinyasm.html

.386
.model			flat,stdcall
option			casemap:none

include			\masm32\include\windows.inc
include			\masm32\include\user32.inc
include			\masm32\include\kernel32.inc
include 		\masm32\include\gdi32.inc
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\gdi32.lib

.data
classname		db "WinFinderPoster",0
about				db "by kero <geocities.com/xmemor> v.2005-05-25",0

.data?
hinst				HINSTANCE ?
hwin				HWND ?
hwnd				HWND ?
hwndx				HWND ?
hwndz				HWND ?
hrgn				HRGN ?
hrn					HRGN ?
threadid		dd ?
diffmin			dd ?
diffmax			dd ?
mess_id			dd ?
point				POINT <?>
rect				RECT <?>

.code                

;################################################################################################

EnChProc proc uses ebx edi hWnd:HWND,prm:DWORD
	local rt:RECT

	mov ebx,hWnd
	cmp ebx,hwin
	jz @1

	invoke IsWindowVisible,ebx
	test eax,eax
	jz @1

@bb:
	invoke GetWindowRect,ebx,addr rt

	mov eax,prm
	test eax,eax
	jnz @f

	invoke GetWindowRgn,ebx,hrn
	test eax,eax
	jz @f

	mov eax,point.x
	sub eax,rt.left
	mov ecx,point.y
	sub ecx,rt.top
	invoke PtInRegion,hrn,eax,ecx

	test eax,eax
	jz @1

@@:
	invoke PtInRect,addr rt,point.x,point.y
	test eax,eax
	jz @1

	mov eax,prm
	test eax,eax
	jnz @ff

;	invoke GetAncestor,ebx,GA_PARENT						; Win OS >= 98, NT 4.0 SP4
			invoke GetWindowLong,ebx,GWL_HWNDPARENT
	test eax,eax
	jz @f
			mov edi,eax
			invoke GetWindow,ebx,GW_OWNER
			cmp eax,edi
			jz @f
			mov ebx,edi
	jmp @bb

@@:
	mov eax,hwndz
	test eax,eax
	jz @f
	cmp ebx,hwndz
	jnz @1
@@:
	mov hwndz,ebx

@ff:
	invoke GetWindowRect,hWnd,addr rt

	mov eax,point.x		; eax=min
	sub eax,rt.left
	mov ecx,rt.right
	sub ecx,point.x
	mov edx,ecx				; edx=max
	cmp eax,ecx
	jle @f
	mov edx,eax
	mov eax,ecx
@@:
	mov ecx,point.y
	sub ecx,rt.top
	mov ebx,ecx
	cmp eax,ecx
	jle @f
	mov ebx,eax
	mov eax,ecx
@@:
	cmp edx,ebx
	jge @f
	mov edx,ebx
@@:
	mov ecx,rt.bottom
	sub ecx,point.y
	mov ebx,ecx
	cmp eax,ecx
	jle @f
	mov ebx,eax
	mov eax,ecx
@@:
	cmp edx,ebx
	jge @f
	mov edx,ebx
@@:
	cmp eax,diffmin
	jg @1
	jl @f
	cmp edx,diffmax
	jg @1
@@:
	mov diffmin,eax
	mov diffmax,edx
	mov eax,hWnd
	mov hwndx,eax
@1:
	xor eax,eax
	inc eax
	ret
EnChProc endp

;################################################################################################

WindowUnderCursor proc uses ebx edi esi prm:DWORD
	local rt:RECT
	local hr:HRGN

	invoke GetCursorPos,addr point
	mov ebx,SWP_NOSIZE or SWP_NOMOVE or SWP_NOACTIVATE
	xor eax,eax
	mov hwndx,eax
	mov hwndz,eax
	mov diffmax,eax
	dec eax
	shr eax,1
	mov diffmin,eax
	invoke GetDesktopWindow
	invoke EnumChildWindows,eax,offset EnChProc,prm
	invoke GetWindowRect,hwndx,addr rt

;	invoke EqualRect,addr rect,addr rt
;	test eax,eax
;	jnz @@@
	mov eax,rect.left
	cmp eax,rt.left
	jnz @f
	mov eax,rect.top
	cmp eax,rt.top
	jnz @f
	mov eax,rect.right
	cmp eax,rt.right
	jnz @f
	mov eax,rect.bottom
	cmp eax,rt.bottom
	jz @@@
@@:
	invoke SendMessage,HWND_BROADCAST,mess_id,hwin,hwndx

;	invoke CopyRect,addr rect,addr rt
	mov eax,rt.left
	mov rect.left,eax
	mov eax,rt.top
	mov rect.top,eax
	mov eax,rt.right
	mov rect.right,eax
	mov eax,rt.bottom
	mov rect.bottom,eax

	mov edi,rt.right
	sub edi,rt.left
	mov esi,rt.bottom
	sub esi,rt.top
	mov ebx,3
	add edi,ebx
	add esi,ebx
	invoke SetRectRgn,hrgn,ebx,ebx,edi,esi
	add edi,ebx
	add esi,ebx
	invoke CreateRectRgn,0,0,edi,esi
	mov hr,eax
	invoke CombineRgn,hr,hr,hrgn,RGN_DIFF
	invoke SetWindowRgn,hwin,hr,1
	invoke DeleteObject,hr

	sub rt.left,ebx
	sub rt.top,ebx
	mov ebx,SWP_SHOWWINDOW
@@@:
	invoke SetWindowPos,hwin,HWND_TOPMOST,rt.left,rt.top,edi,esi,ebx
	mov eax,hwndx
	mov hwnd,eax
	ret
WindowUnderCursor endp

;################################################################################################

WndThreadProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov eax,uMsg
	.if eax==WM_DESTROY || eax==WM_CLOSE || eax==WM_NCDESTROY
;		invoke PostQuitMessage,0

	.elseif eax==mess_id && wParam==0 && lParam==0
		xor eax,eax
		dec eax
		mov rect.left,eax
		invoke WindowUnderCursor,0

	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
WndThreadProc endp

;################################################################################################

WinThread proc hInst:HINSTANCE,hPrevInst:HINSTANCE,lpszArgs:LPSTR,CmdShow:DWORD
	local wc:WNDCLASS
	local msg:MSG
	mov wc.style,0
	mov wc.lpfnWndProc,offset WndThreadProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	mov eax,hInst
	mov wc.hInstance,eax
	mov wc.hbrBackground,COLOR_WINDOW+2
	mov wc.lpszMenuName,0
	mov wc.lpszClassName,offset classname
	invoke LoadIcon,0,IDI_APPLICATION
	mov wc.hIcon, eax
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	invoke RegisterClass,addr wc
	and eax,0ffffh
	mov mess_id,eax
	invoke CreateWindowEx,WS_EX_TOPMOST or WS_EX_TOOLWINDOW,offset classname,0,WS_POPUP,0,0,0,0,0,0,hInst,0
	mov hwin,eax
	invoke ShowWindow,hwin,CmdShow
	invoke UpdateWindow,hwin
	.while TRUE
		invoke GetMessage,addr msg,0,0,0
		.break .if (!eax)
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov eax,msg.wParam
	ret
WinThread endp

;################################################################################################

ThreadProc proc prm:DWORD
	invoke WinThread,hinst,0,0,SW_SHOWDEFAULT
	invoke ExitThread,0
	ret
ThreadProc endp

;################################################################################################

start:

;		invoke RegisterWindowMessage,offset string
; or
;		invoke RegisterClipboardFormat,offset string
; or
;		.data?
;		wcs		WNDCLASS <?>
;		.code
;		mov wcs.lpszClassName,offset string
;		invoke RegisterClass,offset wcs
;		and eax,0ffffh
;
;	test eax,eax
;	jz @exit
;	mov mess_id,eax

	invoke FindWindow,offset classname,0
	test eax,eax
	jnz @exit
	mov rect.left,eax
	mov rect.top,eax
	mov rect.right,eax
	mov rect.bottom,eax
	invoke CreateRectRgn,eax,eax,eax,eax
	mov hrgn,eax
	invoke CreateRectRgn,0,0,0,0
	mov hrn,eax
	invoke GetModuleHandle,0
	mov hinst,eax
	invoke CreateThread,0,0,addr ThreadProc,0,0,addr threadid
	invoke CloseHandle,eax
@@:
	invoke Sleep,20
	invoke GetKeyState,VK_ESCAPE
	test eax,8000h
	jnz @f
	invoke GetKeyState,VK_HOME
	and eax,8000h
	invoke WindowUnderCursor,eax
	jmp @b
@@:
	invoke DeleteObject,hrgn
	invoke DeleteObject,hrn
@exit:
	invoke ExitProcess,0
end start

;################################################################################################
